//author: sidsingh
//LCD HD44780 subroutines
#include<htc.h>
#include"lcd-4bit-custom.h" //include this file in main.c also

#define _XTAL_FREQ 20000000
#define	LCD_RS RD4		// Register Select (0=command, 1=data)
#define LCD_EN RD5		// Enable bit
// RD0..RD3 ==> LCD D4..D7


void eninstr()
{
	LCD_EN=1;
	__delay_us(40);
	LCD_EN=0;
}
	
void endata()
{
	LCD_RS=1;
	LCD_EN=0;
	__delay_us(40);
		LCD_EN=1;
	__delay_us(40);
	LCD_EN=0;
	LCD_RS=0;
}


void write_lcd_command(unsigned char lcd_data)
{
unsigned char temp1;
temp1= (lcd_data >> 4) & 0x0F;
PORTD = (PORTD & 0xF0) | temp1;
eninstr();
temp1= lcd_data & 0x0F;
PORTD = (PORTD & 0xF0) | temp1;	
eninstr();
}
	
void write_lcd_char(unsigned char lcd_data)
{
unsigned char temp1;

temp1= (lcd_data >> 4) & 0x0F;
PORTD = (PORTD & 0xF0) | temp1;
endata();
temp1= lcd_data & 0x0F;
PORTD = (PORTD & 0xF0) | temp1;	
endata();

}	
	

void write_lcd_string(const char *s)
{
	while(*s)
	write_lcd_char(*s++);	
}	


void initlcd()
{
	__delay_ms(20);
	LCD_RS=0;
	
	write_lcd_command(0x33);
	__delay_ms(5);
	write_lcd_command(0x32);
	__delay_ms(5);
	write_lcd_command(0x28);
	__delay_ms(5);
	write_lcd_command(0x0c);
	__delay_ms(5);
	clrlcd();
		
}

void clrlcd()
{
		LCD_RS=0;
		write_lcd_command(0x01);
		__delay_ms(2);
		
}

void goto_lcd(unsigned char pos)
{
	write_lcd_command(0x80+pos);
}

/* write a number */
void write_lcd_number(unsigned long no, char base, char digit,char decimal)
{
char i,j,di[10];
for(i=0;i<=9;i++) di[i]=0;
i=0;
do{
	di[i]=no%base;
	no=no/base;
	i=i+1;}
while(no!=0);
for(j=digit;j>0;j--)
{
	if (decimal!=0 && j==decimal)write_lcd_char('.');
	if(di[j-1]<=9) write_lcd_char(di[j-1]+'0');
	else write_lcd_char(di[j-1]-10+'A');}
}


void lcd_fill_custom()
{
    char i,j;
    i=0;j=0;
   write_lcd_command(0x40);
    for(i=1;i<=8;i++)
	
	 {
        for(j=8;j>i;j--)
        write_lcd_char(0x00);
        for(j=i;j>0;j--)
        write_lcd_char(0x0f);
    }
}
